#include <iostream>
#include <cctype>
#include <string>

using namespace std;

struct Bolesnik {
	string krvnaGrupa;
	int brojDoza;
};

void dozaO(Bolesnik lik, int o)
{
	if(lik.krvnaGrupa == "O")
	{
		if(lik.brojDoza <= o)
		{
			cout << lik.brojDoza << " " << 0 << " " << 0 << " " << 0 << endl;
			o -= 1;
		}
	}
}

void dozaA(Bolesnik lik, int a, int o)
{
	if(lik.krvnaGrupa == "A")
	{
		if(lik.brojDoza <= a)
		{
			cout << 0 << " " << lik.brojDoza << " " << 0 << " " << 0 << endl;
			a -= 1;
		}
		else if(lik.brojDoza <= o)
		{
			cout << lik.brojDoza << " " << 0 << " " << 0 << " " << 0 << endl;
			o -= 1;
		}
	}
}

void dozaB(Bolesnik lik, int b, int o)
{
	if(lik.krvnaGrupa == "B")
	{
		if(lik.brojDoza <= b)
		{
			cout << 0 << " " << 0 << " " << lik.brojDoza << " " << 0 << endl;
			b -= 1;
		}
		else if(lik.brojDoza <= o)
		{
			cout << lik.brojDoza << " " << 0 << " " << 0 << " " << 0 << endl;
			o -= 1;
		}
	}
}

void dozaAB(Bolesnik lik, int ab, int a, int b, int o)
{
	if(lik.krvnaGrupa == "AB")
	{
		if(lik.brojDoza <= ab)
		{
			cout << 0 << " " << 0 << " " << 0 << " " << lik.brojDoza << endl;
			ab -= 1;
		}
		else if(lik.brojDoza <= a)
		{
			cout << 0 << " " << lik.brojDoza << " " << 0 << " " << 0 << endl;
			a -= 1;
		}
		else if(lik.brojDoza <= b)
		{
			cout << 0 << " " << 0 << " " << lik.brojDoza << " " << 0 << endl;
			b -= 1;
		}
		else if(lik.brojDoza <= o)
		{
			cout << lik.brojDoza << " " << 0 << " " << 0 << " " << 0 << endl;
			o -= 1;
		}
	}
}

int main()
{
	int n, o, a, b, ab;
	cin >> n;
	cin >> o >> a >> b >> ab; // broj doza u bolnici
	string grupa;
	int doza;
	Bolesnik lik[n];
	
	for(int i = 0; i < n; i++) 
	{
		cin >> grupa >> doza;
		lik[i].krvnaGrupa = grupa;
		lik[i].brojDoza = doza;
	}
	
	cout << "moguce" << endl;
	
	for(int i = 0; i < n; i++) 
	{
		dozaO(lik[i], o);
		dozaA(lik[i], a, o);
		dozaB(lik[i], b, o);
		dozaAB(lik[i], ab, a, b, o);
	}
}